<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section>
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>What crop did you cultivate on this plot during the previous campaign</translate> {{ previousCampaign ? ` (${previousCampaign.name})?` : '?' }}
            </div>

            <q-select
              :model-value="$store.state.fertilizationPlan.parameters.previous_plant_species"
              :options="plantSpeciesOptions"
              option-value="id"
              option-label="name"
              filled
              @filter="filterPlantSpecies"
              use-input
              input-debounce="200"
              :loading="$apollo.queries.plantSpecies.loading"
              @update:model-value="onInputPlantSpecies"
            />
            <q-select
              :model-value="$store.state.fertilizationPlan.parameters.previous_plant_species_profile"
              :options="plantSpeciesProfiles"
              option-value="id"
              option-label="profile_name"
              class="q-mt-sm"
              filled
              :loading="$apollo.queries.plantSpeciesProfiles.loading"
              :disable="!$store.state.fertilizationPlan.parameters.previous_plant_species || !plantSpeciesProfiles || !plantSpeciesProfiles.length"
              @update:model-value="onInputPlantSpeciesProfile"
            />
          </q-card-section>
          <q-card-section>
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>What yield did you achieve then</translate>?
            </div>

            <q-input
              filled
              type="number"
              :label="$gettext('Yield')"
              :suffix="$gettext('kg/ha')"
              :model-value="$store.state.fertilizationPlan.parameters.previous_yield"
              @update:model-value="value => updateYield(value)"
              :rules="yieldRules"
              :min="yieldMin"
              :max="yieldMax"
            />
          </q-card-section>

          <!-- <q-card-section class="q-pt-none">
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>Had you collected the residues before the campaign?</translate>
            </div>

            <q-btn-toggle
              :model-value="$store.state.fertilizationPlan.parameters.previous_collect_residues"
              :options="[{value: true, label:'Yes'}, {value: false, label:'No'}]"
              toggle-color="primary"
              @update:model-value="value => updateParameter('previous_collect_residues', value)"
            />
          </q-card-section> -->

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="$store.state.fertilizationPlan.parameters.previous_plant_species == null || $store.state.fertilizationPlan.parameters.previous_plant_species_profile == null || $store.state.fertilizationPlan.parameters.previous_yield == null"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import FertilicalcMixin from 'src/pages/fieldbook/fertilization/algorithms/fertilicalc/mixins/FertilicalcMixin'

import queryPlantSpecies from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/queryPlantSpecies'
import queryFertilicalcPlantSpeciesProfilesByPlantSpecies from 'src/pages/fieldbook/fertilization/algorithms/fertilicalc/graphql/queryFertilicalcPlantSpeciesProfilesByPlantSpecies'
import queryCampaignByHoldingCampaignId from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/queryCampaignByHoldingCampaignId'
import queryPreviousCampaignByCampaignId from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/queryPreviousCampaignByCampaignId'

export default {
  name: 'FertilicalcPreviousCampaignPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, FertilicalcMixin],
  data () {
    return {
      plantSpecies: [],
      plantSpeciesProfiles: [],
      campaign: null,
      previousCampaign: null,
      filterValue: null
    }
  },
  apollo: {
    plantSpecies: {
      query: queryPlantSpecies,
      notifyOnNetworkStatusChange: true,
      update: data => data.plant_species
    },
    plantSpeciesProfiles: {
      query: queryFertilicalcPlantSpeciesProfilesByPlantSpecies,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plant_species_id: this.$store.state.fertilizationPlan.parameters.previous_plant_species.id
        }
      },
      update (data) {
        if (data.fertilicalc__plant_species_profile.length && this.$store.state.fertilizationPlan.parameters.previous_plant_species_profile == null) {
          this.onInputPlantSpeciesProfile(data.fertilicalc__plant_species_profile[0])
          this.updateParameter('previous_plant_species_profile', data.fertilicalc__plant_species_profile[0])
          if (this.$store.state.fertilizationPlan.parameters.previous_yield == null) {
            this.updateParameter('previous_yield',
              data.fertilicalc__plant_species_profile[0].default_medium_yield ||
              data.fertilicalc__plant_species_profile[0].default_high_yield ||
              data.fertilicalc__plant_species_profile[0].default_low_yield)
          }
        }
        return data.fertilicalc__plant_species_profile
      },
      skip () {
        return !this.$store.state.fertilizationPlan.parameters.previous_plant_species
      }
    },
    campaign: {
      query: queryCampaignByHoldingCampaignId,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          holding_campaign_id: this.$store.state.fastplatform.holdingCampaign.id
        }
      },
      update (data) {
        return data.campaign[0]
      }
    },
    previousCampaign: {
      query: queryPreviousCampaignByCampaignId,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          campaign_id: this.campaign.id
        }
      },
      update (data) {
        return data.campaign[0]
      },
      skip () {
        return !this.campaign || !this.campaign.id
      }
    }
  },
  mounted () {
    if (!this.$store.state.fertilizationPlan.parameters.previous_plant_species) {
      this.updateParameter('previous_plant_species', this.$store.state.fertilizationPlan.parameters.plant_species)
      this.updateParameter('previous_plant_species_profile', this.$store.state.fertilizationPlan.parameters.plant_species_profile)
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Previous campaign')
    },
    pageSubTitle () {
      return 'FertiliCalc'
    },
    plantSpeciesOptions () {
      const options = this.plantSpecies
      if (this.filterValue) {
        return options.filter(v => v.name?.toLowerCase().indexOf(this.filterValue) > -1)
      } else {
        return options
      }
    },
    yieldRules () {
      return [
        val => !isNaN(val) || `${this.$gettext('Yield must be a number')}`,
        val => !!val || `* ${this.$gettext('This field is required')}`,
        val => val > 0 || `${this.$gettext('Yield must be positive')}`
      ]
    }
  },
  methods: {
    filterPlantSpecies (val, update, abort) {
      update(() => {
        this.filterValue = val.toLowerCase()
      })
    },
    onClickNext () {
      this.$router.push({
        name: 'fertilicalcPreviousCampaignResidues'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'fertilicalcIrrigationYield'
      })
    },
    onInputPlantSpecies (value) {
      this.updateParameter('previous_plant_species', value)
      this.updateParameter('previous_plant_species_profile', null)
    },
    onInputPlantSpeciesProfile (value) {
      this.updateParameter('previous_plant_species_profile', value)
      // update yield
      this.updateYield(
        value.default_medium_yield ||
        value.default_high_yield ||
        value.default_low_yield
      )
      // reset previous fraction residues and incorporation parameters
      this.updateParameter('previous_fraction_residues', null)
      this.updateParameter('previous_incorporate_residues_with_tillage', null)
    },
    updateYield (value) {
      if (isNaN(value)) {
        this.updateParameter('previous_yield', null)
      } else {
        value = parseFloat(value)
        this.updateParameter('previous_yield', value < this.yieldMin ? this.yieldMin : value > this.yieldMax ? this.yieldMax : value)
      }
    }
  }
}
</script>
